regina::NMatrixRing< T > Class Template Reference
Mathematical Support

Represents a matrix of elements from a given ring T. More...

`#include <maths/nmatrix.h>`

Inheritance diagram for regina::NMatrixRing< T >:

## Public Member Functions

| NMatrixRing (unsigned long rows, unsigned long cols)
| Creates a new matrix of the given size. More...
| NMatrixRing (const NMatrix< T > &cloneMe)
| Creates a new matrix that is a clone of the given matrix. More...
void | makeIdentity ()
| Turns this matrix into an identity matrix. More...
bool | isIdentity () const
| Determines whether this matrix is a square identity matrix. More...
bool | isZero () const
| Determines whether this is the zero matrix. More...
void | addRow (unsigned long source, unsigned long dest)
| Adds the given source row to the given destination row. More...
void | addRow (unsigned long source, unsigned long dest, T copies)
| Adds the given number of copies of the given source row to the given destination row. More...
void | addCol (unsigned long source, unsigned long dest)
| Adds the given source column to the given destination column. More...
void | addCol (unsigned long source, unsigned long dest, T copies)
| Adds the given number of copies of the given source column to the given destination column. More...
void | multRow (unsigned long row, T factor)
| Multiplies the given row by the given factor. More...
void | multCol (unsigned long column, T factor)
| Multiplies the given column by the given factor. More...
std::auto_ptr< NMatrixRing< T > > | operator* (const NMatrixRing< T > &other) const
| Multiplies this by the given matrix, and returns the result. More...
template<class MatrixClass >
std::auto_ptr< MatrixClass > | multiplyAs (const NMatrixRing< T > &other) const
| Multiplies this by the given matrix, and returns a new matrix of subclass MatrixClass. More...
T | det () const
| Evaluates the determinant of the matrix. More...
Public Member Functions inherited from regina::NMatrix< T >
| NMatrix (unsigned long rows, unsigned long cols)
| Creates a new matrix of the given size. More...
| NMatrix (const NMatrix &cloneMe)
| Creates a new matrix that is a clone of the given matrix. More...
virtual | ~NMatrix ()
| Destroys this matrix. More...
void | initialise (const T &value)
| Sets every entry in the matrix to the given value. More...
void | initialise (List allValues)
| A Python-only routine that fills the matrix with the given set of elements. More...
unsigned long | rows () const
| Returns the number of rows in this matrix. More...
unsigned long | columns () const
| Returns the number of columns in this matrix. More...
T & | entry (unsigned long row, unsigned long column)
| Returns the entry at the given row and column. More...
const T & | entry (unsigned long row, unsigned long column) const
| Returns the entry at the given row and column. More...
bool | operator== (const NMatrix< T > &other) const
| Determines whether this and the given matrix are identical. More...
bool | operator!= (const NMatrix< T > &other) const
| Determines whether this and the given matrix are different. More...
virtual void | writeMatrix (std::ostream &out) const
| Writes a complete representation of the matrix to the given output stream. More...
void | swapRows (unsigned long first, unsigned long second)
| Swaps the elements of the two given rows in the matrix. More...
void | swapColumns (unsigned long first, unsigned long second)
| Swaps the elements of the two given columns in the matrix. More...

## Static Public Attributes

static T | zero
| Zero in the underlying ring. More...
static T | one
| One (the multiplicative identity) in the underlying ring. More...

## Additional Inherited Members

Protected Attributes inherited from regina::NMatrix< T >
unsigned long | nRows
| The number of rows in the matrix. More...
unsigned long | nCols
| The number of columns in the matrix. More...
T ** | data
| The actual entries in the matrix. More...

## Detailed Description

### template<class T>
class regina::NMatrixRing< T >

Represents a matrix of elements from a given ring T.

Note that many important functions (such as entry()) are inherited from the parent class NMatrix, and are not documented again here.

Precondition
  Type T has a default constructor and overloads the assignment (`=`) operator.
  An element t of type T can be written to an output stream out using the standard expression `out << t`.
  Type T provides binary operators `+`, `-` and `*` and unary operators `+=`, `-=` and `*=`.
  Type T has a long integer constructor. That is, if `a` is of type T, then `a` can be initialised to a long integer `l` using `a(l)`. Here the value 1 refers to the multiplicative identity in the ring T.

Python:
  Not present, although the subclass NMatrixInt is.

## Constructor & Destructor Documentation

template<class T>

regina::NMatrixRing< T >::NMatrixRing | ( | unsigned long | rows,
|  | unsigned long | cols
| ) |  |

inline

Creates a new matrix of the given size.

All entries will be initialised using their default constructors.

Precondition
  The given number of rows and columns are both strictly positive.

Parameters

  rows | the number of rows in the new matrix.
  cols | the number of columns in the new matrix.

template<class T>

regina::NMatrixRing< T >::NMatrixRing | ( | const NMatrix< T > & | cloneMe | ) |

inline

Creates a new matrix that is a clone of the given matrix.

Parameters

  cloneMe | the matrix to clone.

## Member Function Documentation

template<class T>

void regina::NMatrixRing< T >::addCol | ( | unsigned long | source,
|  | unsigned long | dest
| ) |  |

inline

Adds the given source column to the given destination column.

Precondition
  The two given columns are distinct and between 0 and columns()-1 inclusive.

Parameters

  source | the columns to add.
  dest | the column that will be added to.

template<class T>

void regina::NMatrixRing< T >::addCol | ( | unsigned long | source,
|  | unsigned long | dest,
|  | T | copies
| ) |  |

inline

Adds the given number of copies of the given source column to the given destination column.

Note that copies is passed by value in case it is an element of the row to be changed.

Precondition
  The two given columns are distinct and between 0 and columns()-1 inclusive.

Parameters

  source | the columns to add.
  dest | the column that will be added to.
  copies | the number of copies of source to add to dest.

template<class T>

void regina::NMatrixRing< T >::addRow | ( | unsigned long | source,
|  | unsigned long | dest
| ) |  |

inline

Adds the given source row to the given destination row.

Precondition
  The two given rows are distinct and between 0 and rows()-1 inclusive.

Parameters

  source | the row to add.
  dest | the row that will be added to.

template<class T>

void regina::NMatrixRing< T >::addRow | ( | unsigned long | source,
|  | unsigned long | dest,
|  | T | copies
| ) |  |

inline

Adds the given number of copies of the given source row to the given destination row.

Note that copies is passed by value in case it is an element of the row to be changed.

Precondition
  The two given rows are distinct and between 0 and rows()-1 inclusive.

Parameters

  source | the row to add.
  dest | the row that will be added to.
  copies | the number of copies of source to add to dest.

template<class T>

T regina::NMatrixRing< T >::det | ( |  | ) | const

inline

Evaluates the determinant of the matrix.

This algorithm has quartic complexity, and uses the dynamic programming approach of Mahajan and Vinay. For further details, see Meena Mahajan and V. Vinay, "Determinant: Combinatorics, algorithms, and complexity", Chicago J. Theor. Comput. Sci., Vol. 1997, Article 5.

Precondition
  This is a square matrix.

Returns
  the determinant of this matrix.

template<class T>

bool regina::NMatrixRing< T >::isIdentity | ( |  | ) | const

inline

Determines whether this matrix is a square identity matrix.

If this matrix is square, isIdentity() will return `true` if and only if the matrix has ones in the main diagonal and zeroes everywhere else.

If this matrix is not square, isIdentity() will always return `false` (even if makeIdentity() was called earlier).

Returns
  `true` if and only if this is a square identity matrix.

template<class T>

bool regina::NMatrixRing< T >::isZero | ( |  | ) | const

inline

Determines whether this is the zero matrix.

Returns
  `true` if and only if all entries in the matrix are zero.

template<class T>

void regina::NMatrixRing< T >::makeIdentity | ( |  | ) |

inline

Turns this matrix into an identity matrix.

This matrix need not be square; after this routine it will have `entry(r,c)` equal to `one` if `r == c` and `zero` otherwise.

template<class T>

void regina::NMatrixRing< T >::multCol | ( | unsigned long | column,
|  | T | factor
| ) |  |

inline

Multiplies the given column by the given factor.

Note that factor is passed by value in case it is an element of the row to be changed.

Precondition
  The given column is between 0 and columns()-1 inclusive.

Parameters

  column | the column to work with.
  factor | the factor by which to multiply the given column.

template<class T>
template<class MatrixClass >

std::auto_ptr<MatrixClass> regina::NMatrixRing< T >::multiplyAs | ( | const NMatrixRing< T > & | other | ) | const

inline

Multiplies this by the given matrix, and returns a new matrix of subclass MatrixClass.

This matrix is not changed.

Precondition
  The number of columns in this matrix equals the number of rows in the given matrix.
  The class MatrixClass is a subclass of NMatrixRing<T>, and can be fully initialised by calling the two-argument constructor (passing the row and column counts) and then settng individual elements via data[r][c]. In particular, there should not be any new data members that need explicit initialisation.

Python:
  Not present, but the python multiplication operator performs the same task (see the python notes for operator *).

Parameters

  other | the matrix by which to multiply this matrix.

Returns
  a newly allocated matrix representing `this * other`.

template<class T>

void regina::NMatrixRing< T >::multRow | ( | unsigned long | row,
|  | T | factor
| ) |  |

inline

Multiplies the given row by the given factor.

Note that factor is passed by value in case it is an element of the row to be changed.

Precondition
  The given row is between 0 and rows()-1 inclusive.

Parameters

  row | the row to work with.
  factor | the factor by which to multiply the given row.

template<class T>

std::auto_ptr<NMatrixRing<T> > regina::NMatrixRing< T >::operator* | ( | const NMatrixRing< T > & | other | ) | const

inline

Multiplies this by the given matrix, and returns the result.

This matrix is not changed.

Precondition
  The number of columns in this matrix equals the number of rows in the given matrix.

Warning
  The returned matrix will be of the exact class NMatrixRing<T>, even if both this and other are of some common subclass of NMatrixRing<T>. If you need a subclass to be returned, consider calling multiplyAs() instead.

Python:
  The multiplication operator for a subclass (such as NMatrixInt) will return a new matrix of that same subclass. That is, the python multiplication operator really calls multiplyAs(), not this routine.

Parameters

  other | the matrix by which to multiply this matrix.

Returns
  a newly allocated matrix representing `this * other`.

The documentation for this class was generated from the following file:

- maths/nmatrix.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).